;
; Controla el tiempo de ejecucin
;
[BITS 16]
; Segmento de CODIGO ------------------------------------------------------

[SEGMENT CODE]
; Subrutina que pone una marca de tiempo ----------------------------------
[GLOBAL Start]
Start:
      PUSH DS
      PUSH AX
      PUSH DX                        ; Guarda los registros a usar
      CALL far RELOJ                 ; Halla el tiempo actual
      MOV WORD [DS:TIME],AX
      MOV WORD [DS:TIME+2],DX        ; Guarda el tiempo en centsimas
      POP DX
      POP AX
      POP DS                         ; Recupera los registros
      RETF

; Subrutina que cierra la marca de tiempo y halla la diferencia
[GLOBAL Stop]
Stop:
      CALL far RELOJ                 ; Calcula el tiempo actual
      MOV BX,_DATA
      MOV DS,BX
      MOV ES,BX                      ; Inicio los segmentos
      SUB AX,WORD [DS:TIME]
      SBB DX,WORD [DS:TIME+2]        ; Halla la diferencia
      MOV WORD [DS:TIME],AX
      MOV WORD [DS:TIME+2],DX        ; Almacena el resultado
      MOV AL,' '
      MOV CX,7
      STD
      MOV DI,TNUM
      REP STOSB                      ; Borro el ltimo resultado
      MOV BX,10
      MOV AX,WORD [DS:TIME]          ; Tomo la parte baja
      MOV DI,TNUM - 1
DIG:  XOR DX,DX                      ; Slo una palabra
      DIV BX
      ADD DL,30H                     ; Obtengo el digito
      MOV [ES:DI],DL                 ; Lo guardo
      DEC DI
      AND AX,AX                      ; Compruebo si he terminado
      JNZ DIG                        ; Convierto el nmero a caracteres
      MOV BP,TCAD
      MOV AX,1301H
      MOV BX,14                      ; Atributo de color
      MOV DX,0202H
      MOV CX,TFIN-TCAD
      INT 10H                        ; Imprimo la cadena resultado
      RETf

; -------------------------------------------------------------------------

RELOJ:
      PUSH BX
      PUSH CX                  ; Guardo los registros
      MOV AX,_DATA
      MOV DS,AX                ; Inicio el segmento de datos
      MOV AH,2CH
      INT 21H                  ; Resuelvo el tiempo actual
      XOR BH,BH
      MOV BL,DL                ; Sec100
      XOR AH,AH
      MOV AL,DH                ; Sec
      MOV DL,100
      MUL DL
      ADD BX,AX                ; Sec100 + 100*Sec
      XOR AH,AH
      MOV AL,CL                ; Min
      MOV DX,6000
      MUL DX
      ADD AX,BX
      ADC DX,0                 ; Sec100 + 100*Sec + 6000*Min
      POP CX
      POP BX                   ; Recupero los registros
      RETf

; Segmento de DATOS -------------------------------------------------------
[SEGMENT _DATA CLASS=DATA]

TIME  DD 0                ; Almacena el tiempo transcurrido
TCAD  DB 'Tiempo : '
      DB '000000'
TNUM  DB ' centsimas',13,10
TFIN  DB 0

