#ifndef _CSR_H_
#define _CSR_H_

// Registros especificos de confuracion PCI

#define DEVICE_ZR36120 0x6120
#define VENDOR_ZORAN 0x11de

#define PCI_COMMAND 0x04
#define PCI_BASE_ADDRESS 0x10
#define PCI_LATENCY 0x0d

#define LATENCIA 32 // los tres bits menos significativos son 0

#define PCI_COMMAND_MEMORY 0x02
#define PCI_COMMAND_MASTER 0x04

#endif
