	DOSSEG
	.MODEL LARGE

	.CODE
	PUBLIC   _LeerDW, _EscribirDW, _uDelay
; Lee una doble palabra en una direccion lineal de 32 bits
_LeerDW  PROC FAR, DirLineal:DWORD
	.386p
	;
	push	bp
	mov	bp,sp
	push	di
	push  ds
	xor   ax,ax
	mov   ds,ax
	mov   edi, DirLineal
	mov   eax, [edi]
	mov   edx,eax
	shr   edx,16         ;Devuelve dato DWORD en DX:AX
	pop   ds
	pop	di
	mov	sp,bp
	pop	bp
	retf
_LeerDW ENDP

; Escribe una doble palabra en una direccion lineal de 32 bits
_EscribirDW PROC FAR, DirLineal:DWORD, Dato:DWORD
	.386p
	;
	push	bp
	mov	bp,sp
	push  ax
	push	di
	push  ds
	xor   ax,ax
	mov   ds,ax
	mov   eax, Dato
	mov	edi, DirLineal





	mov   [edi],eax
	pop   ds
	pop	di
	pop   ax
	mov	sp,bp
	pop	bp
	retf
_EscribirDW ENDP

; Implementa un retardo de 2 microsegundos
_uDelay PROC FAR
	pusha
	push	es
	mov	ax,40h
	mov	es,ax
	cli
	mov	al,00110110b
	out	43h,al
	jmp	$+2
	mov	cx,2
	mov	al,cl
	out	40h,al
	jmp	$+2
	mov	al,ch
	out	40h,al
	jmp	$+2
	sti
	mov	bx,es:[6ch]
BUCLE:
	cmp	bx,es:[6ch]
	je		BUCLE
	cli
	mov	al,00110110b
	out	43h,al
	jmp	$+2
	mov	cx,0
	mov	al,cl
	out	40h,al
	jmp	$+2
	mov	al,ch
	out	40h,al
	jmp	$+2
	sti
	pop	es
	popa
	retf
_uDelay ENDP
	END
